function JMLR_test
addpath('../');

clc;
clear;
close all;


%%%% data %%%%%%%
napp = 200;
ntest = 2000;
noise_prop = 0;
[x,y,xt,yt]=gdataset('checkers',napp,ntest,noise_prop);

SD = simpleData(x,y);
SD.kernelType = 'tanh';
SD.kernelParam = [-1,-1];
C=10;
    
% load ESVM
    SM = loadESVM(SD,C);
    [app,test] = performance(SM,xt,yt)
    figure;
    SM.print2D();
    
% % load ESVM-L
%     SM2 = loadESVML(SD,C,40);
%     [app,test] = performance(SM2,xt,yt)
%     figure;
%     SM2.print2D();
%     
% % load KSVM
%     SM3 = loadKSVM(SD,C);
%     [app,test] = performance(SM3,xt,yt)
%     figure;
%     SM3.print2D();


keyboard
end

function SM = loadESVM(SD,C)
tic;
SM = simpleModelENPSVM(SD,C,SD.n);
SM.train;
toc
end

function SM = loadESVML(SD,C,nbEig)
tic;
SM = simpleModelENPSVM(SD,C,nbEig);
SM.train;
toc
end


function SM = loadKSVM(SD,C)
tic;
SM = simpleModelNPSVM(SD,C);
SM.train;
toc

end


function [perfApp,perf] = performance(SM,xt,yt)

ypred = SM.test(xt);
perf = length(find(sign(ypred)==yt))/(length(ypred));
disp(['Test perf : ', num2str(100*perf), '%']);

ypred = SM.test(SM.SD.trainvec);
perfApp = length(find(sign(ypred)==SM.SD.trainlab))/(length(ypred));
disp(['App perf : ', num2str(100*perfApp), '%']);
end