% paper figure

addpath('../');
% test
clc;
clear all;
close all;


napp = 300;
ntest = 2000;
[x,y,xt,yt]=gdataset('checkers',napp,ntest,0);


SD = simpleData(x,y);
%SD.kernelType = 'rbf';
%SD.kernelParam = [3];
SD.kernelType = 'tanh';
SD.kernelParam = [-0.5,0.1];
SD.getKernelValues(1:SD.n); % pre-compute kernel
[V D] = eigs(SD.kernelCache(1:SD.n,1:SD.n),50);

figure;
subplot(1,3,2);
plot(1:length(D),sort(diag(D)));
title('10 largest (absolute) eigenvalues');

C=1000;
tic;
SM = simpleModelENPSVM(SD,C,500000);
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
subplot(1,3,1);
SM.print2D();
title('Decision function based on exact decomposition');

SD.clear;
tic;
SM2 = simpleModelENPSVM(SD,C,50);

SM2.train;
toc
tic;
[ypred,perf] = SM2.test(xt,yt);
toc
disp(perf)
subplot(1,3,3);
SM2.print2D();
title('Decision function based on partial decomposition (50 largest eigenvalues)');
