function f = kernelLab(SD,ind,Q,lambda)

%switch SD.kernelType
%if strcmp(SD.kernelType,'rbf') % rbf
    if nargin==2
        dot_b = sum(SD.trainvec(:,ind).*SD.trainvec(:,ind),1);
        dot_a = sum(SD.trainvec.*SD.trainvec,1);
        unitvec = ones(1,SD.n);
        f = SD.trainvec(:,ind)' * SD.trainvec;
        for i=1:length(ind)
            f(i,:) = SD.trainlab(ind(i)) * (exp(SD.kernelParam(1) * ...
                (2 * f(i,:) - dot_a - dot_b(i) * unitvec)) .* SD.trainlab');
        end
        %         elseif nargin==4
        %             dot_a = sum(x1.*x1,1);
        %             dot_b = sum(x2.*x2,1);
        %             unitvec = ones(size(x1,2),1);
        %             A = lambda/(1+Q*lambda);
        %             f = x1' * x2;
        %             if lambda==0
        %                 for i=1:size(x2,2)
        %                     f(:,i) = (x4(i)==x3) .* (exp(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec)));
        %                 end
        %             else
        %                 B = 1/lambda + (Q-1);
        %                 for i=1:size(x2,2)
        %                     %                      f(:,i) = -B.^(x4(i)==x3) .* ((-1/A)*exp(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec)));
        %                     f(:,i) = (-B).^(x4(i)==x3) .* (-A*exp(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec)));
        %                 end
        %             end
    else
        error('wrong number of input arguments');
    end
    %     case 'rbfmax'
    %         if nargin==5
    %             unitvec = ones(1,size(x1,2));
    %             f = zeros(length(x1),length(x2));
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * (max(exp(d.sigma * (-max(abs(x1 -  x2(:,i)*unitvec) ,[], 1)')),d.conv) .* x3);
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'rbf1'
    %         if nargin==5
    %             unitvec = ones(1,size(x1,2));
    %             f = zeros(length(x1),length(x2));
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * (exp(d.sigma * (-sum(abs(x1 -  x2(:,i)*unitvec) , 1)')) .* x3);
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'rbfconv'
    %         if nargin==3
    %             dot_a = sum(x1.*x1, 1);
    %             unitvec = ones(1,size(x1,2));
    %             f = x1' * x1;
    %             for i=1:size(x1,2)
    %                 f(:,i) = x2(i) * (max(exp(d.sigma * (2 * f(:,i) - dot_a' - dot_a(i) * unitvec)),d.conv) .* x2);
    %             end
    %         elseif nargin==5
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * (max(exp(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec)),d.conv) .* x3);
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'ratio'
    %         if nargin==3
    %             dot_a = sum(x1.*x1, 1);
    %             unitvec = ones(1,size(x1,2));
    %             f = x1' * x1;
    %             for i=1:size(x1,2)
    %                 f(:,i) = x2(i) * ((1-((-2 * f(:,i) + dot_a' + dot_a(i) * unitvec)./(-2 * f(:,i) + dot_a' + dot_a(i) * unitvec + d.sigma))) .* x2);
    %             end
    %         elseif nargin==5
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * ((1-((-2 * f(:,i) + dot_a' + dot_b(i) * unitvec)./(-2 * f(:,i) + dot_a' + dot_b(i) * unitvec+d.sigma))) .* x3);
    %             end
    %         elseif nargin==7
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             A = lambda/(1+Q*lambda);
    %             if lambda==0
    %                 for i=1:size(x2,2)
    %                     f(:,i) = (x4(i)==x3).* ((1-((-2 * f(:,i) + dot_a' + dot_b(i) * unitvec)./(-2 * f(:,i) + dot_a' + dot_b(i) * unitvec+d.sigma))) );
    %                 end
    %             else
    %                 B = 1/lambda + (Q-1);
    %                 for i=1:size(x2,2)
    %                     f(:,i) = (-B).^(x4(i)==x3).* (-A*(1-((-2 * f(:,i) + dot_a' + dot_b(i) * unitvec)./(-2 * f(:,i) + dot_a' + dot_b(i) * unitvec+d.sigma))) );
    %                 end
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'simq'
    %         if nargin==3
    %             dot_a = sum(x1.*x1, 1);
    %             unitvec = ones(1,size(x1,2));
    %             f = x1' * x1;
    %             for i=1:size(x1,2)
    %                 f(:,i) = x2(i) * (sqrt(1-((-2 * f(:,i) + dot_a' + dot_a(i) * unitvec)./(-2 * f(:,i) + dot_a' + dot_a(i) * unitvec + d.sigma))) .* x2);
    %             end
    %         elseif nargin==5
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * (sqrt(1-((-2 * f(:,i) + dot_a' + dot_b(i) * unitvec)./(-2 * f(:,i) + dot_a' + dot_b(i) * unitvec+d.sigma))) .* x3);
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'gauss'
    %         if nargin==3
    %             dot_a = sum(x1.*x1, 1);
    %             unitvec = ones(1,size(x1,2));
    %             f = x1' * x1;
    %             for i=1:size(x1,2)
    %                 f(:,i) = (1/sqrt(2*pi*d.sigma))*(x2(i) * (exp((2 * f(:,i) - dot_a' - dot_a(i) * unitvec)./(2*d.sigma)) .* x2));
    %             end
    %         elseif nargin==5
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             for i=1:size(x2,2)
    %                 f(:,i) = (1/sqrt(2*pi*d.sigma))*(x4(i) * (exp((2 * f(:,i) - dot_a' - dot_b(i) * unitvec)./(2*d.sigma)) .* x3));
    %             end
    %         elseif nargin==7
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             A= lambda/(1+Q*lambda);
    %             if lambda==0
    %                 for i=1:size(x2,2)
    %                     f(:,i) = (1/sqrt(2*pi*d.sigma))*(x4(i) ==x3) .* (exp((2 * f(:,i) - dot_a' - dot_b(i) * unitvec)./(2*d.sigma)) );
    %                 end
    %             else
    %                 B= 1/lambda + (Q-1);
    %                 for i=1:size(x2,2)
    %                     f(:,i) = (1/sqrt(2*pi*d.sigma))*(-B).^(x4(i)==x3) .* (-A*exp((2 * f(:,i) - dot_a' - dot_b(i) * unitvec)./(2*d.sigma)) );
    %                 end
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'poly'
    %         if nargin==3
    %             f = (d.scale * (x1' * x1) + d.offset).^d.degree;
    %             for i=1:size(x1,2)
    %                 f(:,i) = x2(i) * (f(:,i) .* x2);
    %             end
    %         elseif nargin==5
    %             f = (d.scale * x1' * x2 + d.offset).^d.degree;
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * (f(:,i) .* x3);
    %             end
    %         elseif nargin==7
    %             f = (d.scale * x1' * x2 + d.offset).^d.degree;
    %             A= lambda/(1+Q*lambda);
    %             if lambda==0
    %                 for i=1:size(x2,2)
    %                     f(:,i) = x4(i) * (f(:,i) .* x3);
    %                 end
    %             else
    %                 B= 1/lambda + (Q-1);
    %                 for i=1:size(x2,2)
    %                     f(:,i) = (-B).^(x4(i)==x3).* (-A*f(:,i));
    %                 end
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'polynorm'
    %         temp.name = 'poly';
    %         temp.scale = d.scale;
    %         temp.degree = d.degree;
    %         if nargin==3
    %             f = kernelPol(temp, x1, x2)./(sqrt(diag(kernelPol(temp, x1, x2))*diag(kernelPol(temp, x1, x2))'));
    %         elseif nargin==5
    %             f = kernelPol(temp, x1, x2, x3, x4)./(sqrt(diag(kernelPol(temp, x1, x3))*diag(kernelPol(temp, x2, x4))'));
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'epanech'
    %         if nargin==3
    %             dot_a = sum(x1.*x1, 1);
    %             unitvec = ones(1,size(x1,2));
    %             f = x1' * x1;
    %             for i=1:size(x1,2)
    %                 f(:,i) = x2(i) * (max(1+(d.sigma * (2 * f(:,i) - dot_a' - dot_a(i) * unitvec)) .* x2,0));
    %             end
    %         elseif nargin==5
    %             dot_a = sum(x1.*x1,1);
    %             dot_b = sum(x2.*x2,1);
    %             unitvec = ones(size(x1,2),1);
    %             f = x1' * x2;
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) *(max(1+(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec)),0)).* x3;
    %             end
    %         else
    %             error('wrong number of input arguments');
    %         end
    %     case 'tanh'
    %         if nargin==3
    %             f = tanh(d.a * (x1' * x1) + d.r);
    %             for i=1:size(x1,2)
    %                 f(:,i) = x2(i) * (f(:,i) .* x2);
    %             end
    %         elseif nargin==5
    %             f = tanh(d.a * x1' * x2 + d.r);
    %             for i=1:size(x2,2)
    %                 f(:,i) = x4(i) * (f(:,i) .* x3);
    %             end
    %             %          if nargin==3
    %             %  	    f = tanh(d.a*(x1'*x1).*(x2*x2') + d.r);
    %             %          elseif nargin==5
    %             %  	    f = tanh(d.a*(x1'*x2).*(x3*x4') + d.r);
    %         else
    %             error('wrong number of input arguments');
    %         end
%end
